"""
Product initialization

$Id: __init__.py 9 2007-06-06 14:45:50Z gael.le-mignot $
"""

from Products.CMFCore.utils import ToolInit, ContentInit
from Products.CMFCore.DirectoryView import registerDirectory

from Products.Archetypes.public import process_types, listTypes

from config import GLOBALS, SKINS_DIR, PROJECT_NAME

registerDirectory(SKINS_DIR, GLOBALS)


def initialize(context):
    ## Initialize tools
    from tools import SignableEventTool

    tools = (SignableEventTool.SignableEventTool, )

    ToolInit(SignableEventTool.META_TYPE,
             tools=tools,
             icon='tool.png').initialize(context)


    from content import *

    content_types, constructors, ftis = process_types(
        listTypes(PROJECT_NAME),
        PROJECT_NAME)

    allTypes = zip(content_types, constructors)
    for atype, constructor in allTypes:
        kind = "%s: %s" % (PROJECT_NAME, atype.archetype_name)
        permission = '%s: Add %s' % (PROJECT_NAME,
                                     atype.archetype_name)
        ContentInit(kind,
                    content_types=(atype, ),
                    permission=permission,
                    extra_constructors=(constructor, ),
                    fti=ftis).initialize(context)

